open Term 

let rec subst x t = function 
    | TVar y when x = y -> t
    | TAdd (e1, e2) -> failwith "not implemented yet"
    | TSub (e1, e2) -> failwith "not implemented yet"
    | TMul (e1, e2) -> failwith "not implemented yet"
    | TEq (e1, e2) -> failwith "not implemented yet"
    | TLeq (e1, e2) -> failwith "not implemented yet"
    | TApp (e1, e2) -> failwith "not implemented yet"
    | TFun (y, e) when y<> x -> failwith "not implemented yet"
    | TIf (e1, e2, e3) -> failwith "not implemented yet"
    | TPair (e1, e2) -> failwith "not implemented yet"
    | TLet (y, e1, e2) -> failwith "not implemented yet"
    | TLetTuple (y, z, e1, e2) -> failwith "not implemented yet"
    | TFix (f, y, e) when f <> x && y <> x -> failwith "not implemented yet"
    | TSeq (e1, e2) -> failwith "not implemented yet"
    | TAss (e1, e2) -> failwith "not implemented yet"
    | TDeref e -> failwith "not implemented yet"
    | TRef e -> failwith "not implemented yet"
    | e -> e

let subst_value x v = subst x (TCst v)

let rec eval = function 
    | TVar x -> failwith "not implemented yet"
    | TCst v -> failwith "not implemented yet"
    | TAdd (e1, e2) -> failwith "not implemented yet"
    | TMul (e1, e2) -> failwith "not implemented yet"
    | TSub (e1, e2) -> failwith "not implemented yet"
    | TEq (e1, e2) -> failwith "not implemented yet"
    | TLeq (e1, e2) -> failwith "not implemented yet"
    | TApp (e1, e2) -> failwith "not implemented yet"
    | TFun (x, e) -> failwith "not implemented yet"
    | TIf (e1, e2, e3) -> failwith "not implemented yet"
    | TPair (e1, e2) -> failwith "not implemented yet"
    | TLet (x, e1, e2) -> failwith "not implemented yet"
    | TLetTuple (x,y,e1,e2) -> failwith "not implemented yet"
    | TFix (f, x, e) as fix -> failwith "not implemented yet"
    | TRef t -> failwith "not implemented yet"
    | TDeref t -> failwith "not implemented yet"
    | TAss (e1, e2) -> failwith "not implemented yet"
    | TSeq (e1, e2) -> failwith "not implemented yet"


