type token =
  | LPAR
  | RPAR
  | LET
  | IN
  | EQUAL
  | LEQ
  | IDENT of (string)
  | INT of (int)
  | BOOL of (bool)
  | PLUS
  | TIMES
  | MINUS
  | FIX
  | UNIT
  | IF
  | THEN
  | ELSE
  | FUN
  | ARROW
  | COMMA
  | REC
  | REF
  | BANG
  | COLEQ
  | SEQ
  | EOF

val term :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Term.t
